// EditBox.h: interface for the CEditBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EDITBOX_H__1366E1DC_D7EF_4C6D_BBDA_EC403334A9C8__INCLUDED_)
#define AFX_EDITBOX_H__1366E1DC_D7EF_4C6D_BBDA_EC403334A9C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WindowVirt.h"

typedef CWinTraits<WS_CHILD | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL> EditTraits;

class CEditBox  : public CWindowImpl<CEditBox,CWindowVirt, EditTraits>
{
public:
    CEditBox();
    CEditBox(DWORD style) : m_style(style) { };
	virtual ~CEditBox();

    // To avoid having to create our own custom window class, follow
    // what WTL did and define GetWndClassName() together with Create().

	HWND Create(HWND hWndParent, RECT& rect, LPCTSTR szWindowName = NULL,
			DWORD dwStyle = 0, DWORD dwExStyle = 0,
			UINT nID = 0U, LPVOID lpCreateParam = NULL)
	{
		return CWindow::Create(GetWndClassName(), hWndParent, rect, szWindowName,
                               m_style | GetWndStyle(dwStyle), GetWndExStyle(dwExStyle), nID, lpCreateParam);
	}

    static LPCTSTR GetWndClassName()
    {
        return _T("EDIT");
    }

    BEGIN_MSG_MAP(CEditBox)
    END_MSG_MAP()

private:
    DWORD m_style;
};

#endif // !defined(AFX_EDITBOX_H__1366E1DC_D7EF_4C6D_BBDA_EC403334A9C8__INCLUDED_)
