// ViewInvalidator.h: interface for the CViewInvalidator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIEWINVALIDATOR_H__5849B8CF_5F9F_4679_93AF_71F421FB7288__INCLUDED_)
#define AFX_VIEWINVALIDATOR_H__5849B8CF_5F9F_4679_93AF_71F421FB7288__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Invalidator.h"
#include "ViewWindow.h"

// CLASS:  CViewInvalidator
//
// PURPOSE: Wrap up invalidation/redisplay of a particular window.
//          The HWND representing the window can be configured dynamically.
//
class CViewInvalidator  : public CInvalidator
{
public:
    CViewInvalidator() : m_view(NULL) { }
    CViewInvalidator(CViewWindow *view) : m_view(view) { }
    virtual ~CViewInvalidator() { }

    void SetView(CViewWindow *view) { m_view = view; }
    void Invalidate() { if (m_view) m_view->Changed(); }
private:
     CViewWindow *m_view;
};

#endif // !defined(AFX_VIEWINVALIDATOR_H__5849B8CF_5F9F_4679_93AF_71F421FB7288__INCLUDED_)

