// ViewSettings.h: interface for the CViewSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIEWSETTINGS_H__C5BF9CFB_9E14_46F0_B7D4_221C93DB5AA3__INCLUDED_)
#define AFX_VIEWSETTINGS_H__C5BF9CFB_9E14_46F0_B7D4_221C93DB5AA3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CViewSettings : public CDialogImpl<CViewSettings>  
{
public:
    enum { IDD = IDD_VIEWSETTINGS };
private:
    int *m_pCopyWidth,*m_pPasses,*m_pCopyPasses;
    // Max jitter is logically a real, not an int.  For now use an int in
    // the UI, since there aren't SetDlgItemDouble and GetDlgItemDouble.
    // (SourceSafe version 3 has an almost-working attempt.)
    double *m_pMaxJitter;
public:
    CViewSettings(int *pCopyWidth, int *pPasses, int *pCopyPasses, double *pMaxJitter)
        : m_pCopyWidth(pCopyWidth)
        , m_pPasses(pPasses)
        , m_pCopyPasses(pCopyPasses)
        , m_pMaxJitter(pMaxJitter)
        {}
    // ~CViewSettings() {}

    BEGIN_MSG_MAP(CViewSettings)
        MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
        COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
        COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
    END_MSG_MAP()

    LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/ ,
                         LPARAM /*/*lParam*/, BOOL& /*bHandled*/) 
    {
        SetDlgItemInt(IDC_COPY_WIDTH,*m_pCopyWidth,FALSE);
        SetDlgItemInt(IDC_DISPLAY_PASSES,*m_pPasses,FALSE);
        SetDlgItemInt(IDC_DISPLAY_MAX_JITTER,(int)(*m_pMaxJitter * 10),FALSE);
        SetDlgItemInt(IDC_DISPLAY_COPY_PASSES,*m_pCopyPasses,FALSE);
        return 0;
    }

    LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID,
                       HWND /*hWndCtl*/, BOOL& /*bHandled*/)
    {
        if (wID == IDOK) {
            int newWidth = GetDlgItemInt(IDC_COPY_WIDTH,NULL,FALSE);
            if (newWidth > 0) *m_pCopyWidth = newWidth;
            int newPasses = GetDlgItemInt(IDC_DISPLAY_PASSES,NULL,FALSE);
            if (newPasses > 0) *m_pPasses = newPasses;
            int newMaxJitter = GetDlgItemInt(IDC_DISPLAY_MAX_JITTER,NULL,FALSE);
            if (newMaxJitter >= 0) *m_pMaxJitter = (double) (newMaxJitter/10.0);
            int newCopyPasses = GetDlgItemInt(IDC_DISPLAY_COPY_PASSES,NULL,FALSE);
            if (newCopyPasses > 0) *m_pCopyPasses = newCopyPasses;
        }
        EndDialog(wID);
        return 0;
    }
};

#endif // !defined(AFX_VIEWSETTINGS_H__C5BF9CFB_9E14_46F0_B7D4_221C93DB5AA3__INCLUDED_)
